pipeline
{
    environment
    {
        PROJECT = 'ansible:operation'
        ECRURL = 'https://396676188700.dkr.ecr.ap-southeast-1.amazonaws.com'
        ECRCRED = 'ecr:ap-southeast-1:ecrcred'
        GIT_BRANCH_OR_TAG = sh(returnStdout: true, script:
'''\
     #!/bin/bash -e
     GIT_REMOTE=$(git remote)
     if git rev-parse --verify -q refs/remotes/${GIT_REMOTE}/${GIT_BRANCH}^{} | grep -q ${GIT_COMMIT}
       then echo branch
       exit 0
     elif git rev-parse --verify -q refs/tags/${GIT_BRANCH}^{} | grep -q ${GIT_COMMIT}
       then echo tag
       exit 0
     else echo unknown
       exit 0
     fi
'''.stripIndent()).trim()
    }
    agent {
        docker {
            image 'ansible:operation'
            args '-u root -v /etc/passwd:/etc/passwd:ro -v /etc/group:/etc/group:ro -v /etc/shadow:/etc/shadow:ro -v /var/run/docker.sock:/var/run/docker.sock -v /var/lib/jenkins/.docker:/root/.docker:rw -v /var/lib/jenkins/.aws:/root/.aws -v /var/lib/jenkins/.ssh/id_rsa:/root/.ssh/id_rsa -v /var/lib/jenkins/.ssh/id_rsa.pub:/root/.ssh/id_rsa.pub'
            registryUrl 'https://396676188700.dkr.ecr.ap-southeast-1.amazonaws.com/'
            registryCredentialsId 'ecr:ap-southeast-1:ecrcred'
        }
    }
    stages
    {
		stage('run-ansible-for-staging-deploy')
        {
            when {
                branch 'master'
            }
            steps
            {
                sh 'ansible-playbook /root/scoopcor-staging.yml -i /etc/ansible/hosts --private-key /root/.ssh/id_rsa'
            }
        }
        stage('run-ansible-for-production')
		{
			when
            {
                expression
                {
                    env.GIT_BRANCH_OR_TAG == 'tag'
                }
            }
			steps
			{
                script
                {
                    def branch_name = env.BRANCH_NAME.replaceAll('\\/','-')
                }
				sh """ansible-playbook /root/scoopcor-prod.yml -i /etc/ansible/hosts --private-key /root/.ssh/id_rsa --extra-vars 'deploy_tag=${branch_name}' """
			}
		}
    }
    post {
        always {
			sh 'rm -f /root/.docker/config.json'
            sh 'rm -f /var/lib/jenkins/.docker/config.json'
            sh 'rm -f /var/lib/jenkins/.dockercfg'
        }
    }
}
